﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace InteropSample
{
    public interface IHello
    {
        string HelloWorld();
    }

    public class Hello3Times : IHello
    {
        public string HelloWorld()
        {
            return "Hello World";
        }

        private string PrivateHello()
        {
            return "Private Hello";
        }

        internal string InternalMethodOnHello3()
        {
            return "Internal Hello";
        }
    }

    public class Hello4Times : Hello3Times
    {
        public string HelloMethodOn4Times()
        {
            return base.HelloWorld();
        }

        public object GetCount()
        {
            return (from s in new[] {"Test", "Test2", "Test3", "Test4"}
                    select s).Count();
        }
    }

    public static class HelloWorld
    {
        public static IHello ReturnHello4TimesAsInterface()
        {
            return new Hello4Times();
        }

        public static Hello3Times ReturnHello3Times()
        {
            return new Hello3Times();
        }
    }
}
